//sram.c

#include "sram.h"

void Init_SRAM(void) {

  RAMAC_bit.RAMTYPE = 0x7;
  RAMAC_bit.RAMBRST = 0x1;

  BWC_bit.RAMBW = 0x2;  //16 bits

}

void WriteSRAM(unsigned long* Add, unsigned long uiData)
{
  *Add = uiData;
}

unsigned long ReadSRAM(unsigned long* Add)
{
  return *Add;
}

unsigned char SRAM_check()
{

  unsigned long i       = 0;      //need for cycles
  unsigned long* pAdd   = 0;      //pointer to SRAM

  //write data to SRAM
  for(i=0, pAdd=(unsigned long *)SRAM_BASE; pAdd < (unsigned long *)SRAM_BASE+SRAM_SIZE/4; ++pAdd,++i)
  {
    WriteSRAM(pAdd, i);
  }

  //read data from SRAM
  for(i=0, pAdd=(unsigned long *)SRAM_BASE; pAdd < (unsigned long *)SRAM_BASE+SRAM_SIZE/4; ++pAdd,++i)
  {
     if (*pAdd != i) break;
  }

  //compare read and write data
  //if data is same pAdd will reach last address
   if (pAdd >= (unsigned long *)SRAM_BASE+SRAM_SIZE/4)
     // OK
     return 0;
   else
     // ERR
     return 1;

}

